<template>
  <div :style="computedStyle">
    <slot></slot>
  </div>
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
enum SpacingMetricsDefaults {
  sm = `0.5rem`,
  md = "1rem",
  lg = "1.5rem",
  xl = "2rem"
}

export default Vue.extend({
  name: "BaseSpacing",
  props: {
    metric: {
      type: String as PropType<SpacingMetricsDefaults>,
      required: false,
      default: "rem"
    },

    x: {
      type: String,
      required: false
    },
    y: {
      type: String,
      required: false
    },
    right: {
      type: String,
      required: false
    },
    left: {
      type: String,
      required: false
    },
    top: {
      type: String,
      required: false
    },
    bottom: {
      type: String,
      required: false
    }
  },
  computed: {
    computedStyle: function() {
      let styles = {};
      if (this.x) {
        styles = {
          ...styles,
          marginRight: `${this.x}${this.metric}`,
          marginLeft: `${this.x}${this.metric}`
        };
      }
      if (this.y) {
        styles = {
          ...styles,
          marginTop: `${this.y}${this.metric}`,
          marginBottom: `${this.y}${this.metric}`
        };
      }
      if (this.top) {
        styles = {
          ...styles,
          marginTop: `${this.top}${this.metric}`
        };
      }
      if (this.bottom) {
        styles = {
          ...styles,
          marginBottom: `${this.bottom}${this.metric}`
        };
      }
      if (this.right) {
        styles = {
          ...styles,
          marginRight: `${this.right}${this.metric}`
        };
      }
      if (this.left) {
        styles = {
          ...styles,
          marginLeft: `${this.left}${this.metric}`
        };
      }
      return styles;
    }
  }
});
</script>
